/*
 * GTK Whistler Theme
 *
 * Copyright (C) 2000 Kazuki Yasumatsu <kyasu@asahi-net.email.ne.jp>
 */

#include <gtk/gtk.h>
#include <gmodule.h>

/* Theme functions to export */

void theme_init(GtkThemeEngine * engine);
void theme_exit(void);

/* Exported vtable from th_draw */

extern GtkStyleClass whistler_default_class;

/* internals */

/* external theme functions called */

static guint
theme_parse_rc_style(GScanner * scanner,
		     GtkRcStyle * rc_style)
{
    guint token;

    token = g_scanner_peek_next_token(scanner);
    while (token != G_TOKEN_RIGHT_CURLY) {
	switch (token) {
	default:
	    g_scanner_get_next_token(scanner);
	    token = G_TOKEN_RIGHT_CURLY;
	    break;
	}

	if (token != G_TOKEN_NONE)
	    return token;

	token = g_scanner_peek_next_token(scanner);
    }

    g_scanner_get_next_token(scanner);

    rc_style->engine_data = NULL;

    return G_TOKEN_NONE;
}

static void
theme_merge_rc_style(GtkRcStyle * dest,
		     GtkRcStyle * src)
{
}

static void
theme_rc_style_to_style(GtkStyle * style,
			GtkRcStyle * rc_style)
{
    style->klass = &whistler_default_class;
}

static void
theme_duplicate_style(GtkStyle * dest,
		      GtkStyle * src)
{
}

static void
theme_realize_style(GtkStyle * style)
{
}

static void
theme_unrealize_style(GtkStyle * style)
{
}

static void
theme_destroy_rc_style(GtkRcStyle * rc_style)
{
}

static void
theme_destroy_style(GtkStyle * style)
{
}

void
theme_init(GtkThemeEngine * engine)
{
    engine->parse_rc_style    = theme_parse_rc_style;
    engine->merge_rc_style    = theme_merge_rc_style;
    engine->rc_style_to_style = theme_rc_style_to_style;
    engine->duplicate_style   = theme_duplicate_style;
    engine->realize_style     = theme_realize_style;
    engine->unrealize_style   = theme_unrealize_style;
    engine->destroy_rc_style  = theme_destroy_rc_style;
    engine->destroy_style     = theme_destroy_style;
    engine->set_background    = NULL;

    {
    GtkRangeClass *rangeclass;
    rangeclass = (GtkRangeClass*)gtk_type_class(gtk_range_get_type());
    rangeclass->stepper_slider_spacing = 0;
    }
}

void
theme_exit(void)
{
}

/* The following function will be called by GTK+ when the module
 * is loaded and checks to see if we are compatible with the
 * version of GTK+ that loads us.
 */
G_MODULE_EXPORT const gchar* g_module_check_init (GModule *module);
const gchar*
g_module_check_init (GModule *module)
{
    return gtk_check_version(GTK_MAJOR_VERSION,
			     GTK_MINOR_VERSION,
			     GTK_MICRO_VERSION - GTK_INTERFACE_AGE);
}
